package bjoerks.httprequest;

import android.app.Activity;
import android.content.Context;
import android.os.Bundle;
import android.widget.TextView;
import bjoerks.net.R;
import bjoerks.net.R.id;

import java.io.BufferedReader;
import java.io.FileOutputStream;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.io.PrintWriter;
import java.net.HttpURLConnection;
import java.net.URL;

import org.apache.http.protocol.HTTP;

public class HttpGetPostRequest extends Activity {
    /** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);
        //doHttpGetRequest();
        doHttpPostRequest();
        
    }
    private void doHttpGetRequest()
    {
        TextView textView1 = (TextView)this.findViewById(id.textView1);
        try{
            URL url = new URL("http://bjoerks.net/http/");
        	HttpURLConnection httpCon = (HttpURLConnection) url.openConnection();
        	if (httpCon.getResponseCode()==HttpURLConnection.HTTP_OK){
        		InputStream inStream = httpCon.getInputStream();
    		    InputStreamReader inReader = new InputStreamReader(inStream);
    		    BufferedReader buffReader = new BufferedReader(inReader);
        		
    		    String text;
    		    text = buffReader.readLine();
    		    while (text != null){
		    		textView1.append("\n"+text);
    		    	
        		    text = buffReader.readLine();
    		    }
    		    buffReader.close();
        	}
        	else{
        		textView1.append("\n returkode:<"+httpCon.getResponseCode()+">");
        		textView1.append("\n returmsg:<"+httpCon.getResponseMessage()+">");
        	}
        		
        }
        catch (Exception e){
    		textView1.append("\n exception-fejl:<"+e.getMessage()+">");
        }
    }
    
    private void doHttpPostRequest()
    {
        TextView textView1 = (TextView)this.findViewById(id.textView1);

    	int a = 7;
    	int b = 3;
    	String soapReqText = 
    		 "<?xml version=\"1.0\" encoding=\"utf-8\"?>" 
    		+"<soap12:Envelope xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" xmlns:xsd=\"http://www.w3.org/2001/XMLSchema\" xmlns:soap12=\"http://www.w3.org/2003/05/soap-envelope\">"
    		+"  <soap12:Body>"
    		+"    <Add xmlns=\"http://tempuri.org/\">"
    		+"       <a>"+ a + "</a>"									// konkret vrdi sttes ind
    		+"       <b>"+ b + "</b>"									// konkret vrdi sttes ind
    		+"    </Add>"
    		+"  </soap12:Body>"
    		+"</soap12:Envelope>"
    		+"\r\n" ;		// slut med linieskift    		
    	
        try{
            // Se krav p url:http://webservicedemo.bjoerks.net/RegneWebService.asmx?op=Add    - her har jeg valgt Soap 1.2
        	URL url = new URL("http://webservicedemo.bjoerks.net/RegneWebService.asmx");
        	HttpURLConnection httpCon = (HttpURLConnection) url.openConnection();
        	httpCon.setUseCaches (false);      
        	httpCon.setDoInput(true);      
        	httpCon.setDoOutput(true);

        	httpCon.setRequestMethod("POST");
        	httpCon.setRequestProperty("Content-Type","text/xml; charset=utf-8");
//        	httpCon.setRequestProperty("SOAPAction","http://tempuri.org/Add");			// skulle med hvis format Soap 1.1
        	
        	httpCon.setRequestProperty("Content-Length",""+soapReqText.length());
        	
			OutputStream outStream = httpCon.getOutputStream();
			PrintWriter outTextStream = new PrintWriter(outStream);
			outTextStream.print(soapReqText);								// ikke println, da linieskift skal med i length
			outTextStream.close();
 
 			if (httpCon.getResponseCode()==HttpURLConnection.HTTP_OK){
        		InputStream inStream = httpCon.getInputStream();
    		    InputStreamReader inReader = new InputStreamReader(inStream);
    		    BufferedReader buffReader = new BufferedReader(inReader);
        		
    		    String text;
    		    text = buffReader.readLine();
    		    while (text != null){
		    		textView1.append("\n"+text);
    		    	
        		    text = buffReader.readLine();
    		    }
    		    buffReader.close();
        	}
        	else{
        		textView1.append("\n returkode:<"+httpCon.getResponseCode()+">");
        		textView1.append("\n returmsg:<"+httpCon.getResponseMessage()+">");
        	}
        		
        }
        catch (Exception e){
    		textView1.append("\n exception-fejl:<"+e.getMessage()+">");
        }
    }
    
    
}